import serializeSelection from 'serialize-selection';
import dom from '../../dom';
export const discriminator = 'TextPositionSelector';
export function serialize(range, referenceElement) {
    referenceElement = referenceElement || dom(range.commonAncestorContainer).closest('[id]');
    if (!referenceElement) {
        throw new Error('reference element not found');
    }
    // modified copy/paste out of 'serialize-selection' module
    const cloneRange = range.cloneRange();
    const startContainer = cloneRange.startContainer;
    const startOffset = cloneRange.startOffset;
    const contentLength = cloneRange.toString().length;
    cloneRange.selectNodeContents(referenceElement);
    cloneRange.setEnd(startContainer, startOffset);
    return {
        end: cloneRange.toString().length + contentLength,
        referenceElementId: referenceElement.id,
        start: cloneRange.toString().length,
        type: discriminator,
    };
}
export function isLoadable(highlighter, data) {
    return !!highlighter.document.getElementById(data.referenceElementId);
}
export function load(highlighter, data) {
    const referenceElement = highlighter.getReferenceElement(data.referenceElementId);
    const selection = serializeSelection.restore(data, referenceElement);
    const range = selection.getRangeAt(0);
    selection.removeAllRanges();
    return range;
}
//# sourceMappingURL=index.js.map